=== Tests/RunCMake/CMP0038/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(${RunCMake_TEST} CXX)
include(${RunCMake_TEST}.cmake)
