=== Tests/RunCMake/set_tests_properties/DIRECTORY-subdir2/CMakeLists.txt ===
set_tests_properties(t3 DIRECTORY ../DIRECTORY-subdir1 PROPERTIES PASS_REGULAR_EXPRESSION "Subdirectory")
