=== Tests/RunCMake/add_subdirectory/CMP0082-Nested/sub/CMakeLists.txt ===
install(CODE "message(STATUS \"sub\")")
